/*
			Ecartypp 1.0
			stdDevP 1.0
	usage : ecartypp(list1[, list2]) if you use the french version...
	or			stddevp(list1[, list2]) if you use the english version...
	
	Calcul de l'cart-type d'une population  partir de la population entire donne en argument
	(list1), ventuellement pondre par liste2 (de mme taille que list1);
	
	Returns the standard deviation of a population (function stdDev() from the TI returns the standard deviation
	of a part of the population); Each list2 element counts the number of consecutive occurrences of the
	corresponding element in list1.
	
	stdDev : 		(sum(Xi - mean(X))^2)/n
	ecartypp :  (sum(Xi - mean(X))^2)/(n-1)
		where X is a list, Xi an element of X, and n the number of elements of X

C Source File
Created 13/11/2003; 19:55:31 by Bastien JANSEN bastien.jansen@wanadoo.fr

*/
#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200


#define MIN_AMS 101           // Compile for AMS 1.00 or higher
#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS


#include <tigcclib.h>
// Main Function
float doSum(float list[], int len){
	int pos;
	float total=0;
	for(pos=0; pos<len;pos++) total+=list[pos];
	return total;
}

void _main(void)
{
	ESI argPtr=top_estack;
	if(ArgCount()==0 || GetArgType(argPtr)!=LIST_TAG){
		ST_showHelp("Usage : ecartypp(list1 [,list2])");
		goto error;
	}	
	float argList[200];
	float argList2[100];
	short pos;
	int args=-1;
	float total=0;
	argPtr--;
	// Gets the first list
	do{
		if(GetArgType(argPtr)==END_TAG){
			if(args==-1){
				ST_showHelp("Error : division by 0 (empty list)");
				goto error;
			}
			else break;
		}
		argList[++args]=(float)GetIntArg(argPtr);
	}while(args<200);
	// Is there a second list??
	if(GetArgType(--argPtr)==LIST_TAG){
		int args2=-1;
		argPtr--;
		// Gets the second list
		do{
			if(GetArgType(argPtr)==END_TAG){
				break;
			}
			argList2[++args2]=(float)GetIntArg(argPtr);
		}while(args2<100);	
		if(++args2!=++args){
			ST_showHelp("Lists must have the same size");
			goto error;
		}else{
				float tmp[200];
				int i=0;
				// Here we put list1 in tmp
				while(argList[i])tmp[i]=argList[i++];
				i=0;
				int pos2=0;
				args=-1;
				// Puts the number of consecutive elements (set in list2) from tmp to list1
				do{
					for(pos=0; pos<argList2[i]; pos++){
						argList[pos2++]=tmp[i];
						++args;
					}
					i++;
				}while(i<args2);
				i=0;
		}
	}
	// Now we can calculate the standard deviation...
	total=doSum(argList, ++args); //++args because the first index in argList is 0, and not 1...
	// argList-mean(argList)->argList
	for(pos=0; pos<args; pos++)	argList[pos]=pow(argList[pos]-(total/args), 2);
	total=doSum(argList, args);
	// Returns the good value
	push_Float(sqrt(total/args));
	// That's all, folks!!
	return;
	error:
		push_longint(-1);
		return;

}
